/* 

	Server for reception of gasoline tanks fuel level

*/
#define debug 1                  // when it's set to "1" it will be verbose
#define PORT 8080


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <curses.h>
#include <unistd.h>

#include <signal.h>





#define LISTENQ 1024

#ifndef INADDR_ANY
	#define INADDR_ANY 0
#endif

#define BUFF_LENGTH 1024

 char suici_sendmx='0';       // with this I signal for the program to close
const char *errstr;
int gazoil=0;

int clrscr() {
                printf("^[[H^[[2J");
                return 0;
}


//#########################
// ctrl+C and other KILL signals capture - signals the program to shut itself down
// otherwize for some half an hour the processes will go zombie

void handler (int signo) {
                          suici_sendmx='1';
                          printf("handler: caught ctrl+C, attempting shutdown...\n");
}

FILE *html;   // in this file the program pukes the received data and they will get displayed as HTML

int main()  {


        
		// client and server structures
	        int server_socket, client_socket;       // socket descriptors

	        struct sockaddr_in server_address, client_address;
	        socklen_t len;  //* socklen_t = socket length type
	        char buffer[BUFF_LENGTH], client_message[BUFF_LENGTH];
	        int num_bytes_received, num_bytes_sent, temp;

		 struct sigaction act;
		pid_t pid_sendmx;
                act.sa_handler = handler;                      
                 act.sa_flags = 0;
                 sigemptyset(&act.sa_mask);
                 //act.sa_nodefer=act.sa_mask;

	        //initializing: INADDR_ANY is zero so I can let anyone connect
	        bzero (&server_address, sizeof (server_address)); //zero the buffer....
	        server_address.sin_family = AF_INET;
	        server_address.sin_addr.s_addr = htonl (INADDR_ANY);

	        printf("init socket...\n");
	        
	        server_address.sin_port = htons (PORT); 
	        server_socket = socket (AF_INET, SOCK_STREAM, 0);
 
	        if (server_socket < 0) {
				           fprintf(stderr, "socket error\n");
				           exit(1);
	        }
                
	        // when automatic shutdown, I let the BSD kernel know I want to use the same connection (IP, PORT) like the previous ones
                                               
	       int yes=1;                             
	       if (setsockopt( server_socket, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(yes)) == -1) {
	                                                                                          perror("setsockopt()");
	                                                                                          exit(1);
	       }
                
	        printf("binding...\n");
	        /*  Bind server socket to a local IPv4 address on the associated port   */
	                 
	        temp = bind (server_socket, (struct sockaddr *)&server_address, sizeof (server_address));

	       if (setsockopt( server_socket, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(yes)) == -1) {
	                                                                                          perror("setsockopt()");
	                                                                                          exit(1);
	       }


	
		// if I have some error, for example bad IP or port already used...
	        if (temp != 0) {
			              fprintf(stderr, "bind error\n");
			              exit(1);  
	        }               

	       printf("port = %d, listen...\n", PORT);
	                     //starting to listen
	       temp = listen (server_socket, LISTENQ);

	       // if again there are problems, for example I'm not root and I do not have any rights to a port smaller than 1024...

	       if (temp != 0) {
	                       fprintf(stderr, "listen error\n");   
	                       exit(1);
		       }
        
		// infinite loop, stop with ctrl-C/kill and the program will perform the above specified procedures...
	       printf("infinite loop... (ctrl-C / kill for exit )\n");
 
        
	       sigaction(SIGINT, &act, NULL);  // intercept ctrl-c / kill
           
	       while (suici_sendmx == '0') {
	                
			                        //client connection accept
			                        sigaction(SIGINT, &act, NULL);
			                        if (suici_sendmx == '0') {
					                                     len =sizeof(client_address);
					                                     client_socket = accept (server_socket, (struct sockaddr *)&client_address, &len);
                                                                                          
					                                     // if any errors...
					                                     sigaction(SIGINT, &act, NULL);
					                                     if (suici_sendmx == '0')
							                                             if (client_socket < 0) {
							                                                                        fprintf(stderr, "accept error\n");
							                                                                        close(client_socket);
							                                                                        exit(1);
				                                             }
        	                              }
	              
	        				/*
					             inet_ntop() converts from binary IP into some IP in xxx.xxx.xxx.xxx form
					             ntohs() returns the port in big-endian system?
					        */
                     
					        printf ("connection accepted from %s on port %d.\n", inet_ntop (AF_INET, &client_address.sin_addr, buffer, 
sizeof (buffer)), ntohs (client_address.sin_port));


/*  warning - analize this:



    Add waitpid() somewhere in the parent process. For example, doing this will help:

    pid=fork();
    if (pid==0) {
        exit(0);    
    } else {
        waitpid(pid);  // <--- this call reaps zombie
        // some parent code ...
    }

    Perform double fork() to obtain grandchild and exit in child while grandchild is still alive. Grandchildren will be automatically adopted by init if their parent (our child) dies, which means if grandchild dies, it will be 
automatically waited on by init. In other words, you need to do something like this:

    pid=fork();
    if (pid==0) {
        // child
        if (fork()==0) {
            // grandchild
            sleep(1); // sleep a bit to let child die first
            exit(0);  // grandchild exits, no zombie (adopted by init)
        }
        exit(0);      // child dies first
    } else {
         waitpid(pid);  // still need to wait on child to avoid it zombified
         // some parent code ...
    }

    Explicitly ignore SIGCHLD signal in parent. When child dies, parent gets sent SIGCHLD signal which lets it react on children death. You can call waitpid() upon receiving this signal, or you can install explicit ignore signal 
handler (using signal() or sigaction()), which will make sure that child does not become zombie. In other words, something like this:

    signal(SIGCHLD, SIG_IGN); // <-- ignore child fate, don't let it become zombie
    pid=fork();
    if (pid==0) {
        exit(0); // <--- zombie should NOT be created here
    } else {
         // some parent code ...
    }

http://stackoverflow.com/questions/16078985/why-zombie-processes-exist

*/




					        if (pid_sendmx = fork())    {    // transmission process - detach in background.
									       // at each conection timeout and reinit, a new process is generated.
									         // how the f*** I shut down the zombie process?
									        sigaction(SIGINT, &act, NULL);   // capture ctrl+C
										//waitpid(pid_sendmx);
										close(server_socket); // child process does not need to listen on the network
								                while (suici_sendmx == '0') { // <------- warning, it gets stuck into infinite loop, need connection timeout condition!!
														sigaction(SIGINT, &act, NULL);
											
														// receiving stuff
														num_bytes_received=recv(client_socket, client_message, BUFF_LENGTH, 0);
														if (num_bytes_received < 0)  {
																fprintf(stderr, "recv error\n");
																suici_sendmx = '1';
																exit(1);
								                                                }
														client_message[num_bytes_received]='\0';
														printf("gazoil ->  %s\n", client_message);
														//gazoil=-12;
														//sscanf(client_message, "%d", &gazoil);
														write(client_socket, ">\n\0", 3);
														printf("gazoil <- ACK %d bytes\n", num_bytes_sent);
														html=fopen("/usr/local/www/apache24/data/index.html","w");
														fprintf(html,"<html><head><meta http-equiv=\"refresh\" content=\"3\"></head><body><h1>GAZOIL LEVEL: %s</h1>\n",client_message);
														/*if (gazoil < 10) {
																					fprintf(html, "<br><br><h2>WARNING: GAZOIL LEVEL HIGH</h2>");
																					printf("warning gazoil = %d\n",gazoil);
														}*/
														fprintf(html,"</body></html>");
														fclose(html);
                       
											                        //printf("Sent %d bytes\n", num_bytes_sent);

                                     										usleep(1000000);
														bzero(client_message, BUFF_LENGTH);
								                }                   
										            
							                        close(client_socket); //parent process no longer needs this
				             }
				                //else exit(0);
          
					        sigaction(SIGINT, &act, NULL);   // capture ctrl+C
					        if (suici_sendmx == '1') {
							                      printf("caught ctrl-C, shutting down...\n");
							                      close(client_socket);                                                             
					        }



		}
         
		close(client_socket);
                     
return 0;               // signaling normal program termination
}



